一、题目:
给定一个整数数组 nums和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那两个整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
二、解题思路:
- ?题意理解:? 在给定的整数数组中有且仅有两个不同的元素(不同的元素但值可以相同)之和等于整数目标值。
- ?解题思路:? ? 遍历数组从第i个数开始,判断第i个数和第j(i之后的数)个数的和的值是不是目标整数,是的话就输出[i,j]代码如下:
-
class Solution {
public int[] twoSum(int[] nums, int target) {
int[] result = new int[2];
for (int i = 0;i < nums.length-1;i++){
for (int j = i;j < nums.length - 1;j++){
if (nums[i]+nums[j+1] == target){
result[0] = i;
result[1] = j + 1;
}
}
}
return result;
}
} -
提交之后发现这么一段话:你可以想出一个时间复杂度小于?O(n2) ?的算法吗?
? ? ? ? ?没想出来,大佬解法哈希表
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; ++i) {
if (hashtable.containsKey(target - nums[i])) {
return new int[]{hashtable.get(target - nums[i]), i};
}
hashtable.put(nums[i], i);
}
return new int[0];
}
}
作者:LeetCode-Solution
链接:https://leetcode-cn.com/problems/two-sum/solution/liang-shu-zhi-he-by-leetcode-solution/
来源:力扣(LeetCode)
|